import java.util.Objects;

/**
 * class for circle
 */
public class Circle {
    private int radius;

    /**
     * constructor of the circle
     * @param radius of the circle
     */
    public Circle(int radius) {
        this.radius = radius;
    }

    /**
     * @return radius of this circle
     */
    public int getRadius() {
        return radius;
    }

    /**
     * @return perimeter of this circle
     */
    public double calculatePerimeter(){
        return 2*3.14*radius;
    }

    /**
     * @return area of this circle
     */
    public double calculateArea(){
        return 3.14*radius*radius;
    }
    /**
     * @return simulation for drawing a circle
     */
    public void draw(){
        System.out.println("Type: Circle\nPerimeter: " + calculatePerimeter() + "\nArea: " + calculateArea());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Circle)) return false;
        Circle circle = (Circle) o;
        return getRadius() == circle.getRadius();
    }

    @Override
    public int hashCode() {
        return Objects.hash(getRadius());
    }

    @Override
    public String toString() {
        return "Type: Circle\nRadius: "+radius;
    }
}
