import java.util.ArrayList;

/**
 * paint class
 */
public class Paint {
    private ArrayList<Triangle> triangles;
    private ArrayList<Rectangle> rectangles;
    private ArrayList<Circle> circles;

    /**
     * paint constructor
     */
    public Paint() {
        triangles = new ArrayList<>();
        rectangles = new ArrayList<>();
        circles = new ArrayList<>();
    }

    /**
     * @param triangle which is intended to be added
     */
    public void addTriangle(Triangle triangle) {
        triangles.add(triangle);
    }

    /**
     * @param rectangle which is intended to be added
     */
    public void addRectangle(Rectangle rectangle) {
        rectangles.add(rectangle);
    }

    /**
     * @param circle which is intended to be added
     */
    public void addCircle(Circle circle) {
        circles.add(circle);
    }

    /**
     * draws all shapes
     */
    public void drawAll() {
        for (Triangle triangle : triangles) {
            triangle.draw();
        }
        for (Rectangle rectangle : rectangles) {
            rectangle.draw();
        }
        for (Circle circle : circles) {
            circle.draw();
        }
    }

    /**
     * prints all shapes
     */
    public void printAll() {
        for (Triangle triangle : triangles) {
            System.out.println(triangle.toString());
        }
        for (Rectangle rectangle : rectangles) {
            System.out.println(rectangle.toString());
        }
        for (Circle circle : circles) {
            System.out.println(circle.toString());
        }
    }
}
