import java.util.ArrayList;
import java.util.Objects;

/**
 * rectangle class
 */
public class Rectangle {
    /**
     * sides list for rect
     */
    private ArrayList<Integer> sides;

    /**
     * constructor for rectangle
     * @param a side1
     * @param b side2
     * @param c side3
     * @param d side4
     */
    public Rectangle(int a, int b, int c, int d) {
        sides = new ArrayList<>();
        sides.add(a);
        sides.add(b);
        sides.add(c);
        sides.add(d);
    }

    /**
     * @return sides of rect
     */
    public ArrayList<Integer> getSides() {
        return sides;
    }

    /**
     * @return boolean value of being square
     */
    public boolean isSquare() {
        double a, b, c, d;
        a = sides.get(0);
        b = sides.get(1);
        c = sides.get(2);
        d = sides.get(3);
        return (a == b && b == c && c == d);
    }

    /**
     * @return perimeter of rect
     */
    public double calculatePerimeter() {
        return (double) sides.get(0) + sides.get(1) + sides.get(2) + sides.get(3);
    }

    /**
     * @return area of rect
     */
    public double calculateArea() {
        int a, b, c;
        a = sides.get(0);
        b = sides.get(1);
        c = sides.get(2);
        if (a == b)
            return a * c;
        else if (b == c)
            return a * b;
        else
            return b * c;
    }

    /**
     * drawing simulation for this shape
     */
    public void draw() {
        System.out.println("Type: Rectangle\nPerimeter: " + calculatePerimeter() + "\nArea: " + calculateArea());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Rectangle)) return false;
        Rectangle rectangle = (Rectangle) o;
        return getSides().equals(rectangle.getSides());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getSides());
    }

    @Override
    public String toString() {
        return "Type: Rectangle\nSides=" + sides;
    }

}
