import java.util.ArrayList;
import java.util.Objects;

/**
 * triangle class
 */
public class Triangle {
    private ArrayList<Integer> sides;

    /**
     * constructor for triangle
     * @param a first side
     * @param b second side
     * @param c third side
     */
    public Triangle(int a, int b, int c){
        sides=new ArrayList<>();
        sides.add(a);
        sides.add(b);
        sides.add(c);
    }

    /**
     * @return sides of triangle
     */
    public ArrayList<Integer> getSides() {
        return sides;
    }

    /**
     * @return boolean value of being equilateral
     */
    public boolean isEquilateral() {
        double a, b, c;
        a = sides.get(0);
        b = sides.get(1);
        c = sides.get(2);
        return (a == b && b == c);
    }

    /**
     * @return perimeter of triangle
     */
    public double calculatePerimeter(){
        double a, b, c;
        a = sides.get(0);
        b = sides.get(1);
        c = sides.get(2);
        return a+b+c;
    }

    /**
     * @return area of triangle
     */
    public double calculateArea(){
        double a, b, c,s;
        a = sides.get(0);
        b = sides.get(1);
        c = sides.get(2);
        s=calculatePerimeter()/2;
        return Math.sqrt(s*(s-a)*(s-b)*(s-c));
    }

    /**
     * drawing simulation for this shape
     */
    public void draw(){
        System.out.println("Type: Triangle\nPerimeter: "+calculatePerimeter()+"\nArea: "+calculateArea());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Triangle)) return false;
        Triangle triangle = (Triangle) o;
        return getSides().equals(triangle.getSides());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getSides());
    }

    @Override
    public String toString() {
        return "Type: Triangle\nSides=" + sides;
    }
}
